#!/usr/bin/perl  -I/usr/local/lib/simusol
#{[(%
use strict;
use XML::Parser;
use warnings;
use Data::Dumper;
use Text::Abbrev;
use Ayudas;
use Auxiliares;
use Desdexml;
use Algebraico;
use Termicos; 
use Sceptre;
use GlobalesSimusol;
use TraAbrev; 
use Prograf;
use Tablasfuncq;
use Ampliaciones;
use Controles;
use Storable;

#----------------------------------------------------------------------------
use Getopt::Long;
use Pod::Usage; 

$0 =~ m!/([^/]+)\s*$!;
$progname = $1;
my $curdirori = `pwd`; chomp $curdirori; $curdirori .= '/';
$progr{$progname} = '1';
my $largo = 60 - length($progname); 
my $opc_arg = paraimpr3puntos($largo,@ARGV);
my $ref1 = {'curdirori'=>$curdirori};
for my $palabra  ('corto','cortosin','basearchcorto','dirarray') {
    $ref1->{$palabra} = [];
};    
impr_todo(__LINE__.' sims',$ref1);   
crear_tmp_simusol();
interpretar_opciones_1($ref1);
my ($coderr,$mensaje) = ('','');
impr_debug(__LINE__.' sims',Dumper $ref1);
impr_debug(__LINE__.' sim1 opciones',\%opt_hash);  
our %orden_nodos_mod; 
# ---------------------------------------------------------------------------
# si el llamado viene de simusol, todos los archivos son existentes y 
# y son posibles diagramas; si no, puede pasar cualquier cosa
my (@archivos,@archivosmult,@archivossindia,$archivo,$archivosindia);
my $textoARGV = "@ARGV"; 

if (@ARGV == 0 or $textoARGV =~ /[\*\?]/  or ($textoARGV =~ tr/ //) > 6) {
    @archivosmult = elegir_archivos('dia');     
} else {
    @archivosmult = ($textoARGV);
};

if (@archivosmult == 1) {
    @archivos = split /\s+/, $archivosmult[0];
} else {
    @archivos = @archivosmult;
};
my @descartar = grep ($no_ext{$_}, @archivos);
@descartar and avnograv("Simusol no acepta como diagramas archivos de nombre:
     @descartar"); @descartar = (); 
@archivos = grep (do{not $no_ext{$_}}, @archivos);
my (@procesar, @malos,%hasharch);

foreach my $arch (@archivos) {    
     my $archsindia = $arch; 
     $archsindia =~ s/\.dia$//;
     my $archcondia = "$archsindia.dia";
     print "ARCH $arch - $archcondia\n";
     if (-e $archcondia and not -d $archcondia and not -e $archsindia) {
         push @procesar, $archcondia;
         $hasharch{$archcondia} = 'con';
     } elsif (-e $archsindia and not -d $archsindia and not -e $archcondia) { 
         push @procesar, $archsindia;
         $hasharch{$archsindia} = 'sin'
     } elsif (-e $archsindia and -e $archcondia) {
         push @malos, $archcondia,$archsindia;
     } else {
         push @descartar, "$arch: no existe $archcondia ni $archsindia";
     };
};
my $archLSS1 = 'simusol';
if (@procesar == 1) { 
    $archLSS1 = $procesar[0]; $archLSS1 =~ s/\.dia$//;
}; 
abrir_LSS1($archLSS1,$progname,1);
if (@malos) {
    parars1(249,0, "Simusol no trabaja con dos o mas archivos 
    que difieren solamente en tener o no la extensión .dia");  
};
if (@descartar) {
    my $descartados = join "\n      ",@descartar;
    explic("Se han descartado archivos;
      $descartados");
};


if (@procesar == 0) {
    parars1(248,0, "No quedaron archivos para procesar");  
};       

#leer dia
#grabar caj, dia
#crear .paraplot

iniciar(); 

($coderr,my $arch,$mensaje) = traducir(@procesar);
impr_debug(__LINE__.' sim1 $coderr,$arch,$mensaje',[$coderr,$arch,$mensaje]);
$coderr and parars1($coderr,0,$mensaje);
$reffi{$arch}->{clasearch}  eq 'modelo' and parars1(1,0,$arch);
$coderr = interpretar_archivo_circ_cuadros($arch);
$coderr and parars1($coderr,$reffi{$arch});

if ( $reffi{$arch}->{clasearch} eq 'circuito'){
  my ($refcircuito) = con_1archivo($arch);
  $arch=~ s/\.dia$//; 
  store $refcircuito, $arch.".hashplot";
  #crear_Paraplot($refcircuito);
}
 #if $reffi{$arch}->{clasearch} eq 'circuito';

exit;
#termina principal
# ---------------------------------------------------------------------------
sub con_1archivo{
  $archivo = $_[0];
  #print "Simusol 1 109 \n";
  #print Dumper $archivo;
  #exit;
  comfin ('com con_1archivo',@_); 
  #impr_obj(__LINE__.' sim1');
  my $coderr = ''; 
  my $refcircuito = $reffi{$archivo};
  #print "Simusol 1 116 \n";
  #print Dumper $reffi{$archivo};

  ($CORTOA,$PROPIOA) = @$refcircuito{'CORTO','PROPIO'};
  if (scalar (keys %{$refcircuito->{PARAMETROS}})) {
      $coderr = controlar_cadena_param($refcircuito);
      $coderr and parars1($coderr,$refcircuito);
      sust_cadena_par($refcircuito);#en principal
  };
  #imprhash(__LINE__.' sim1 $refcircuito ', %$refcircuito);
  if (scalar keys %{$refcircuito->{cualobjtextonodo}}
      or $refcircuito->{DATOS}) { 
      interpretar_circ($refcircuito); #aquí esta el explotar 
      #en principal; (se ejecuta desplegar temperaturas)
      if ($avisosgrav > 0) {
          parars1(102, $refcircuito
                  ,'Hay errores graves; se interrumpe la traducción');
      };
      analizar_tablas($refcircuito) if scalar keys %hash_tablas_definidas;
      #impr_debug(__LINE__.' sim1 %hash_funciones_definidas'
      #		 , Dumper \%hash_funciones_definidas);
      tratar_funciones($refcircuito) # hay nodos
          if scalar keys %hash_funciones_definidas; 
      $coderr = simpl_parametros($refcircuito); #hay elementos
      $coderr and parars1($coderr,$refcircuito);
      interpretar_resultados($refcircuito,0); #para circuitos
      $avisosgrav and parars1(136,$refcircuito);
  } elsif (scalar (keys %{$refcircuito->{PARAMETROS}})) {
      interpretar_solopar($refcircuito); #esta el explotar
      analizar_tablas($refcircuito);
      tratar_funciones($refcircuito); #no hay nodos, si hay parametros
      $coderr =simpl_parametros($refcircuito);#hay solo parametros
      $coderr and parars1($coderr,$refcircuito);
      interpretar_resultados($refcircuito,1);#solo parámetros
      if ($avisosgrav) {
          system "rm *.paraplot 2> /dev/null";
          parars1(136,$refcircuito);
      };
  };  # a esta altura ya se han leido todas las plantillas necesitadas
  foreach my $que ('DATOS','PARAMETROS','INICIALES','CONTROLES') {
      my @listakey = keys %{$refcircuito->{$que}};
      @listakey = grep( do{$refcircuito->{"TIP$que"}->{$_} eq 'q'
			   and $refcircuito->{"TIPARG$que"}->{$_} =~ /^n+$/}
			,@listakey);
      @listakey and $coderr = evaluar_q_n($refcircuito,$que,@listakey);
      $coderr and parars1($coderr, $refcircuito);
  };
  $coderr =sust_datos_num($refcircuito
       ,['DATOS','PARAMETROS','INICIALES','CONTROLES'],['PARAMETROS','DATOS']);
  $coderr and parars1($coderr,$refcircuito);
  #impr_debug(__LINE__.' sim1 listaINICIALES'
  #     ,$refcircuito->{listaINICIALES} );
  #impr_debug(__LINE__.' sim1 INICIALES',$refcircuito->{INICIALES} );
  controlar_keys_iniciales($refcircuito) 
          if defined $refcircuito->{listaINICIALES};
  #impr_debug(__LINE__.' sim1 listaINICIALES'
  #              ,$refcircuito->{listaINICIALES} );
  #impr_debug(__LINE__.' sim1 INICIALES',$refcircuito->{INICIALES} );
  interpretar_tiempos($refcircuito);
  #filtrar_rerun hay que ejecutarlo antes de interpretar_values_iniciales
  filtrar_rerun(['INICIALES','PARAMETROS','CONTROLES'],$refcircuito); 
  interpretar_values_iniciales($refcircuito) 
      if defined $refcircuito->{listaINICIALES}; 
  #impr_debug(__LINE__.' sim1 listaINICIALES'
  #       ,$refcircuito->{listaINICIALES} );
  controlar_iniciales_il_vc($refcircuito);
  #impr_debug(__LINE__.' sim1 listaINICIALES' ,$refcircuito->{listaINICIALES});
  if ($avisosgrav > 0) {
      explic(
      " Hay errores graves en interpretación o control de valores iniciales
             se interrumpe la traducción de $refcircuito->{CORTO}");
      parars1(185, $refcircuito);
  };
  #impr_datos(__LINE__.' sim1',['CONTROLES'],$refcircuito);
  #De aqui en adelante 
  # o quizas un poco mas alla,los errores graves no impiden la produccion 
  #del archivo .d; queda cargado con $avisosgrav>0 y recien al final
  #aparece el parars1
  realizar_ajustes($refcircuito,'circuito'); 
  parars1(66,0) if $avisosgrav;
  $coderr = resumir_fun_par_tab_var_funx($refcircuito,'circuito');
  $coderr and parars1($coderr,$refcircuito,'');
  #impr_datos(__LINE__.' sim1', ['DATOS','PARAMETROS'], $refcircuito);
  controlar_var($refcircuito); # en principal
  controlar_uso_def_parametros($refcircuito);
  #impr_datos(__LINE__.' sim1', ['DATOS','PARAMETROS'], $refcircuito);
  controlar_uso_def_tablas($refcircuito);
  my @eliminables = keys %{$refcircuito->{USAPAR}};
  @eliminables = grep(do{$refcircuito->{USAPAR}->{$_} == 1
			     and defined $refcircuito->{TIPPARAMETROS}->{$_}
                      and $refcircuito->{TIPPARAMETROS}->{$_} ne ','
	              and not defined $refcircuito->{USAPAR}->{"D$_"}}
                    ,@eliminables);
  eliminar_pars($refcircuito,'circuito', @eliminables) if @eliminables;
  #impr_debug(__LINE__.' sim1 USAPAR', Dumper $refcircuito->{USAPAR});
  controlar_def_funciones_final($refcircuito);
  controlar_uso_funciones($refcircuito);
  controlar_largos($refcircuito);
  controlar_dpar_tiempos($refcircuito);
  my $archguardar = $refcircuito->{PROPIOSINDIA}; 
  my $archguardarcongnus = $refcircuito->{CORTOSINDIA};
  
   #que hace?
  

  if ($opt_hash{todas}) {
      $archguardar = "$archguardar"."_$opt_hash{todas}";
      $archguardar=~ s/\s+/_/g;
      $archguardarcongnus =~ s/([^\/]+)$/gnus\/$1/;
  };
  imprs_lis_obj_sceptre(
        $refcircuito,'circuito',$archguardar, $archguardarcongnus);  
  if ($avisosgrav) {# puedenhaber ocurrido en varias de las llamadas anteriores
      parars1(66,$refcircuito);
  };

  #print "Simusol 1 220 \n";
  #print Dumper $refcircuito;
  #exit;
  #########################################
  #depende de donde esta tomando sacando la info el cuadro

  #crear_Paraplot($refcircuito);
  return ($refcircuito);
  comfin ('fin con_1archivo'); 

} #con_1archivo

# ---------------------------------------------------------------------------


sub crear_Paraplot{

my ($refcircuito)= @_;

my $archguardar = $refcircuito->{PROPIOSINDIA}; 
my $archguardarcongnus = $refcircuito->{CORTOSINDIA};
  
  
  if ($opt_hash{todas}) {
      $archguardar = "$archguardar"."_$opt_hash{todas}";
      $archguardar=~ s/\s+/_/g;
      $archguardarcongnus =~ s/([^\/]+)$/gnus\/$1/;
      $refcircuito->{refvalores}->{GRAFICOS} = undef;
  };
  

if ($refcircuito ->{lisoutputssceptre} or $refcircuito->{refvalores}->{GRAFICOS} )  {   
      prograficar($refcircuito,$archguardar,$archguardarcongnus); # outputs
      #print Dumper  $ archguardar, $archguardarcongnus;
      #parars1(0,$refcircuito);
  }; #elsif (defined $refcircuito->{parsenarchivo}) {
     # parars1(3,$refcircuito,"Todos las variables son constantes;
     # No es necesario (y daria error) ejecutar sceptr")
  #} else {
   #   mensaje('No apareció pedido de resultados;
    #  No se ejecutará sceptre');
     # # el codigo 1 es para .ele o .mod
    #if ($refcircuito->{refvalores}->{GRAFICOS}) {
  #  prograficar($refcircuito);#sin out
   #       parars1(2,$refcircuito);
          #Quizás se haya pedido un gráfico independiente de la simulación;
    #  } else {
         # parars1(4,$refcircuito, 'No se ha pedido nada');
     # }
   #};   
}
# ---------------------------------------------------------------------------

sub iniciar{
  comfin('com iniciar', @_);
  my @yaplantillas = ('Auxiliar','fantasmaplan','Standard','UML','Modelos'); 
  # 'Auxiliar' la usa crear_objeto si no se le da la plantilla
  $nombreplantilla = \@yaplantillas;
  my $ii = 0;
  map(do{$cualplantilla->{$_} = $ii;  $ii++}, @$nombreplantilla); 
  my @yashapes = ('Auxiliarshape', 'fantasmashape' , 'modelo');
  $nombreshape = \@yashapes; 
        @{$comonombre}{'0c0','1c1'} =  ('Auxiliarshape','fantasmashape');
  $ii= 0;
        map(do{$cualshape->{$_} = $ii; $ii++}, @$nombreshape); 
   comfin('fin iniciar');
};
# --------------------------------------------------------------------------
sub interpretar_opciones_1{
    my $ref1 = $_[0]; my ($coderr,$mensaje) = ('','');
  GetOptions(\%opt_hash, 'help','d','version','noverb','noclas','todas=s'
           ,'comocopia','talcual','cadena'
           )
    or pod2usage(2);
  help() if defined $opt_hash{help};
  version() if defined $opt_hash{version};
  print STDERR ".....  coms interpretar_opciones_1($ref1) \n" if $opt_hash{d};
# en este script no cambio de directorio porque hay que manejar 
# más de un archivo

#----------------------------------------------------------------------------
  $debug = $opt_hash{d}; $noverb = $opt_hash{noverb};
  resolver_outdir($ref1);
  calcular_dirsal();
  comfin('fin1 interpretar_opciones_1');
  return $coderr;
}#interpretar_opciones_1    
# --------------------------------------------------------------------------
sub interpretar_archivo_circ_cuadros{
# ya antes se habra ejecutado traducirxml(..); aquí no llegan modelos ni el.
     comfin('com? interpretar_archivo_circ_cuadros', @_);
     explic("Interpretando archivo $_[0] (circuito)");
     my $refcirc = $reffi{$_[0]};
     foreach my $que (keys %{$refcirc->{cualobjmod}}) {# no importa el orden
        $refcirc->{cualobjele}->{$que} = $refcirc->{cualobjmod}->{$que}
     };
#     if (not defined $refcirc->{listaCUADROS}) {
#	 mensaje ('No hay más para hacer; sin cuadros de interés');
#         return 4;
#      };	
#    my @cuadros_circ = grep (/DATOS|PARAMETROS/,@{$refcirc->{listaCUADROS}});
#     @cuadros_circ or do{
#         mensaje ('No hay ninguna simulación para hacer');
#	 return 6;
#     };
     my $coderr;
     if (defined $refcirc->{refvalores}->{FUNCIONES}) {  
         $coderr = asignaciones(['FUNCIONES'],$refcirc,0); #circuito
         $coderr and return $coderr;
     }; 
     if (defined $refcirc->{refvalores}->{PARAMETROS}) { 
         $coderr = asignaciones(['PARAMETROS'],$refcirc,0); #circuito
     } else {$refcirc->{listaPARAMETROS} = [];
     };
     not $coderr and  $coderr  
       = interpretar_cuadros_circ($refcirc);#en interpr._arch._circ_cuadros
     #impr_debug(__LINE__.' sim1 $coderr',$coderr);
     $coderr and return $coderr;
     if (scalar(keys %{$refcirc->{DATOS}})
         + scalar(keys %{$refcirc->{PARAMETROS}}) == 0) {
         #impr_debug(__LINE__.' sim1', Dumper $refcirc->{refvalores});
         porparar1(245, $refcirc,'No se han dado datos numéricos;
                  no hay simulación por hacer');
         return 245;
     };
     $coderr = controlar_circ($refcirc, 'circuito'); #para un circuito
     comfin('fin interpretar_archivo_circ_cuadros'); 
     $coderr and return $coderr;
     return '';
} # interpretar_archivo_circ_cuadros
# ---------------------------------------------------------------------------
sub interpretar_circ{
   comfin('com interpretar_circ',@_); 
   my $refcircuito = $_[0]; my $coderr = '';
   #impr_debug(__LINE__.' sim1 cualobjtextonodo'
   #	      , Dumper $refcircuito->{cualobjtextonodo});
   #marcar_nodos($refcircuito,['TEMP']);# CAMBIAr TEMP por ...
   $CAJAS->{$refcircuito->{CORTO}} .= "#"
           . '.' x 20 . "  Claves de interpretación de simusol\n";
   #my @lisvalues = (values (%{$refcircuito->{DATOS}}),
   #                 values (%{$refcircuito->{PARAMETROS}}),
   #                 values (%{$refcircuito->{INICIALES}}));
   #@lisvalues = grep($_ !~ /^;/, @lisvalues);
   #my $lisvalues = ';' . join(';',@lisvalues) . ';'; 
   $avisosgrav and parars1(181,$refcircuito);
   my @listamod = grep($codlista->[$_] eq 'T', 
                   @{$refcircuito->{lisobjconectsnonodos}});
   if (@listamod) {
       #impr_obj(__LINE__.' sim1');
       desplegar_mod($refcircuito);#en interpretar_circ
       if ($avisosgrav > 0) {
	   parars1(132, $refcircuito
               , "Hay errores graves detectados al interpretar modelos;
             se interrumpe la traducción de $refcircuito->{CORTO}");
       };
   };
   if (@{$refcircuito->{listaPARAMETROS}} > 1) {
       $coderr = simpl_parametros($refcircuito);
       $coderr and parars1($coderr,$refcircuito);
   };
   registrar_equivalencias($refcircuito); #para circuitos
   if (scalar (keys %{$refcircuito->{DATOS}})) { 
       my $reflista = $refcircuito->{equivpalabra};
       $coderr = desplegar_ele($refcircuito,'circuito');#en interpretar_circ
       if ($coderr) {
	   parars1(133, $refcircuito
               ,"Hay errores graves al interpretar elementos;
             se interrumpe la traducción de $refcircuito->{CORTO}");
       };
       completar_nodos($refcircuito);
       foreach my $que ('DATOS','PARAMETROS','INICIALES') {
           my @listakey = keys %{$refcircuito->{$que}};
           @listakey = grep( do{$refcircuito->{"TIP$que"}->{$_} eq 'q'
			   and $refcircuito->{"TIPARG$que"}->{$_} =~ /^n+$/}
			,@listakey);
           @listakey and $coderr = evaluar_q_n($refcircuito,$que,@listakey);
           $coderr and parars1($coderr, $refcircuito);
       };
       temperaturas($refcircuito); 
       normalizar_abreviaturas(['temp','DATOS','PARAMETROS'], $refcircuito);
       my $coderr = sust_datos_num($refcircuito      #para cir 
            ,['PARAMETROS','DATOS','INICIALES'], ['PARAMETROS']);
       $coderr and parars1($coderr,$refcircuito);
       #impr_datos(__LINE__.' sim1', ['DATOS','PARAMETROS'],$refcircuito);
       my $lisque = ['DATOS','INICIALES','PARAMETROS'];
       explot($refcircuito,$lisque); # DATOS, INI.. y PARAM.., para circuitos
       # lo siguiente se hace luego desplegar_ele porque puede
       # aparecer ahi la necesidad 
       #interpretar_values_termico($lisque,$refcircuito);#en interpretar_circ 
   };    
#  REVISAR FALTA ALGO?
} #interpretar_circ
# ---------------------------------------------------------------------------
sub interpretar_solopar{
  comfin('com interpretar_solopar',@_); 
  my $ref = $_[0];
  my $coderr = sust_datos_num($ref,['PARAMETROS'], ['PARAMETROS']);  #solopar
  $coderr and parars1($coderr, $ref);
  explot($ref, ['INICIALES','PARAMETROS']); #  para solopar
  comfin('fin interpretar_solopar'); 
} #interpretar_solopar
# --------------------------------------------------------------------------
sub parars1{
    comfin('comfin parars1',@_);
    # $mensaje se usa para errores detectados por simusol1.pl,
    # que aun no se comunicaron;
    # otros se han comunicado por avgrav,... or porparar 
    # el codigo sera 0 (sin error para el principal) 
    # o el numero del exit
    # $archivo, si se da, es el nombre corto
    # $archivo o $mensaje $refcircuito deben estar presentes 
    #impr_debug(__LINE__.' Glob reffi ', \%reffi);
    my ($codigo,$refcircuito,$mensaje,$archivo)
           = (@_,'','');#a veces se usa sin el tercer y cuarto argumentos  
    if ($refcircuito eq '0' and not $archivo) {
        print "$mensaje\n";
        print LSS1 "codigo s1: $_[0]\n";
        exit $codigo;
    } elsif ($archivo) { 
        $refcircuito = $reffi{$archivo}; 
    }; 
    my ($CORTO, ,$CORTOSINDIA, $PROPIO, $PROPIOSINDIA, $clase)
	= @$refcircuito{'CORTO', , 'CORTOSINDIA', 'PROPIO', 'PROPIOSINDIA'
                      , 'clasearch'};
    $archivo = $CORTO; 
    impr_datos(__LINE__.' Glob',['PARBORR'],$refcircuito);
    my @parborr = sort keys %{$refcircuito->{PARBORR}};
    if (@parborr) {
        open PARAM, ">$CORTOSINDIA.par";
        print PARAM  '#'.'-' x 10 
	    ." Parámetros o elementos sin influencia en los calculos\n";
        print PARAM  "#    de Sceptre, o ya sustituidos en $PROPIOSINDIA.d\n";
        foreach (sort @parborr) {
           print PARAM "$_ = $refcircuito->{PARBORR}->{$_}\n";
        };
        close PARAM;
        my $cuantos = scalar @parborr;
        mensaje( 
        "Hay $cuantos parámetros sin influencia en los cáculos de Sceptre o 
         ya sustituidos; verlos en $PROPIOSINDIA.par");
        explic " ($CORTOSINDIA.par) " if $PROPIO ne $CORTO;
    };
    if ($codigo > 4 and $mensaje) {
        if ($avisosgrav) {explic($mensaje)} else {avgrav($mensaje)};
    };
    my $SI = 'SI';
    if ($codigo <5) {$SI = 'NO';};
    explic("... $progname $SI detectó errores graves en: $archivo ($clase)\n");
    $reffi{$CORTO}->{errores} = 1 if $codigo > 2;
    if ($refcircuito ne '0' and $clase ne 'elementos') {
        my $BASE = $refcircuito->{BASEARCH};
        foreach my $arch (keys %clasearchivos) {
            my $clase = $clasearchivos{$arch}; 
            my $archm = $arch;
            if ($arch !~ /^\//) {
                $archm =$GlobalesSimusol::pwdori . $arch;
            };
            my ($basearch,$propio,$corto,$propiosindia,$cortosindia) 
                = relativizar($archm,$BASE);
            next if $corto eq $CORTOA;
            my $consin = " sin";
	    if ($reffi{$arch}->{errores}) {
                $consin = " con";   
            };       
            mensaje(" $corto: ($clase)$consin errores");
        };#foreach $arch
    };
    if ($codigo) {
          explic('       no hay circuito para simular');
    } else {    
          explic(" $archivo: se puede intentar simularlo");  
    }; 
    
    open CAJ, ">$CORTOSINDIA.caj";
    print CAJ 
        "#    Archivo $PROPIOSINDIA.caj   preparado por simusol1.pl\n";
    if (defined $CAJAS->{$CORTO}) {
         print CAJ "$CAJAS->{$CORTO}\n";   
    } else {
         print CAJ "Nada para poner aquí\n";   
    }
    close CAJ;
    foreach my $keysindia (keys %{$LSS1}) {
        $keysindia =~ /\s/ and error_progr(0,__LINE__.' Glob');
        my $refc = $reffi{$keysindia};
        my $cod = $refc->{errorparar};
        next if defined $cod and $cod eq 0; 
        # significa que no corresponde archivo .lss1 
        #impr_debug(__LINE__.' Glob $CORTOA,$keysindia,$cod'
        #      ,[$CORTOA, $keysindia,$cod]); 
        my $texto = join("\n",@{$LSS1->{$keysindia}}) . "\n";
        open LSS1, ">>$keysindia.lss1";
        print LSS1 $texto;
    };
    mensaje ("codigo s1: $_[0]"); close LSS1;

    exit $codigo; 
};#parars1 
# ----------------------------------------------------------------------------
sub separar_unidad{
    comfin('com separar_unidad', @_);
    use warnings FATAL => qw(numeric uninitialized syntax);
    #los espacios separan; pero si no hay....
    my $par = $_[0];
    my ($valor,$unidad); $unidad = '';
    my $evalpar = eval($par);
    if ($par=~ /(\S+)\s+(\S+)/) {
        (my $parte,$unidad) = ($1,$2);
	defined $parte and $valor = eval($parte);
    } else {
        for (my $i= length($par); $i >=  1; $i--) {
            my $parte = substr($par,0,$i);
	    #impr_debug(__LINE__.' sim1 $parte', $parte);
            $parte = eval($parte);
	    #impr_debug(__LINE__.' sim1 $parte', $parte);
            if (defined $parte) {
                $valor = $parte;
                $unidad = substr($par,$i,length($par)-$i);
                last;
            } else {
                $valor = 1; $unidad = $par
            };    
        };
    };
    comfin('fin separar_unidad', $valor, $unidad);
    return $valor,$unidad
}#separar_unidad
# ----------------------------------------------------------------------------
sub tiempos{
  comfin('com tiempos',@_);
  my ($todo,$ref) = @_; 
    if (defined $ref->{PARAMETROS}) {
      my $todopar = '(' . $todo . ')'; 
      my @pars = grep(/^P/i, split(/\W+/,$todopar));
      foreach my $par (@pars) {
          my $parc = uc($par);
            my $valor = $ref->{PARAMETROS}->{$parc};
          if (defined $valor and $ref->{TIPPARAMETROS}->{$parc} eq 'n') {
              while ($todopar =~ s/(\W)$par(\W)/$1$valor$2/) {};
          };
      };
      $todo = substr($todopar,1,length($todopar)-2);
  };
  my @lista = split /\s*\,\s*/, $todo;
  my (@listavalores, @listaval, @listaunidades, @listaseg);
  my $unip ;
  foreach my $dato (@lista) {
      my ($tiempo,$unidad) = separar_unidad($dato);
      if ($tiempo eq 1 and $unidad eq $dato 
          and not defined $unist{lc($unidad)}) {
          parars1(66,$ref,"No se entiende $dato para indicar duración");
      };
      my ($tipo,$valor) = tipear($ref,$tiempo,0);
      if ($tipo eq 'n') {
          $tiempo = $valor;
      } elsif ($tipo eq 'p' and defined $ref->{PARAMETROS}->{$valor}) {
          $ref->{parametrossustituidos}->{$valor} = 1;  
          $tiempo = $ref->{PARAMETROS}->{$valor};
          $tipo = $ref->{TIPPARAMETROS}->{$valor};
      };
      if ($tipo !~ /[n\,]/) {
          avnoseent(" \" $tiempo \" para dar duraciones para la simulación");
	  next;
      };
      push @listavalores, $tiempo;
      if ($unidad) {
          my $unid = $unist{lc($unidad)};
          if (defined $unid) {
              defined $unip or $unip = $unid;
	  } else {
              avnoseent(" $unidad como unidad de tiempo");
	      pop @listavalores;
              next; 
          };

      };
      push @listaunidades, $unidad;
  }; #foreach  
  if (defined $unip) {
      map(do{$_ eq '' and $_ = $unip}, @listaunidades);
      foreach my $unidad (@listaunidades) {
          my $val = shift @listavalores;
          push @listaval, $val*$factort{$unist{lc($unidad)}};
      };
      @listavalores = @listaval;
  } else {
      $unip = 's';
  };
  comfin('fin tiempos', @listavalores,$unip);
  return \@listavalores,$unip;
}#tiempos
# ---------------------------------------------------------------------------
sub interpretar_cuadros_circ{ 
  # se refiere a los cuadros que describen elementos de circuito
  # ya se habran interpretado los cuadros de los archivos
  # que definen elementos y/o modelos
  # y tambien el cuadro FUNCIONES y PARAMETROS
  # aquí no se cotrola la relacion entre los cuadros y los diagramas 
  comfin('com? interpretar_cuadros_circ', @_);
  my ($refcirc) = @_;
  my $refvalores = $refcirc->{refvalores};
  my $deinteres = 'DATOS|INICIALES|TABLAS_ARCHIVOS|CONTROLES';
  my @lisque = grep($_=~ /$deinteres/,keys %$refvalores);
  my $lisque =\@lisque; 
  my $coderr = asignaciones($lisque,$refcirc,1); #circuito? 
  $coderr and return $coderr;
  my @pard;
  if ($refcirc->{listaPARAMETROS} and $refcirc->{listaINICIALES}) {
      push @pard, @{$refcirc->{listaPARAMETROS}};
      push @pard, @{$refcirc->{listaINICIALES}};
      @pard = union_conjunto (@pard);
      @pard == @{$refcirc->{listaPARAMETROS}} + @{$refcirc->{listaINICIALES}} 
        or parars1(30,$refcirc,'Hay parámetros que aparecen en ambos cuadros
               PARAMETROS INICIALES');
  }; 
  #foreach my $key (keys %{$refcirc->{CONTROLES}}) {
  #    next if $key eq 'START TIME'; next if $key eq 'STOP TIME';
  #    $refcirc->{TIPCONTROLES}->{$key} = 'a';
  #    $refcirc->{TIPARGCONTROLES}->{$key} = '';
  #    $refcirc->{REFARGCONTROLES}->{$key} = 0;
  #};
  #el control de uso de funciones está en interpretar_circ
  if (defined $refcirc->{refvalores}->{TABLAS} or
      defined $refcirc->{refvalores}->{TABLAS_ARCHIVOS}) { 
      $coderr = rec_apl_tablas($refcirc); #en interpretar_cuadros_circ
      $coderr and return $coderr;
  };
  my @paraintegrar = grep (/^D/i,keys %{$refcirc->{PARAMETROS}});
  if (@paraintegrar) {
      $coderr = controlar_iniciales_integr($refcirc,@paraintegrar);
      $coderr and return $coderr;  
  };
  comfin('fin interpretar_cuadros_circ', $lisque, $refcirc,'impr');
  return '';
}   
# ---------------------------------------------------------------------------
sub obedecer_opcion_resultados {
  comfin('com obedecer_opcion_resultados',@_);
  my ($ref,$refcomienzos) = @_;
  #impr_debug(__LINE__.' sim1 comienzos ',$refcomienzos);
  defined $ref->{listasceptre} or $ref->{listasceptre} = [];
  my $cuantos = @{$ref->{listasceptre}}; #por si alguna vez se aumentan
  my ($tipele,$comnombre,$que);
  #impr_debug(__LINE__.' sim1 obedecer',$ref->{hashpalabras});
  my @hashpal = keys %{$ref->{hashpalabras}};
  @hashpal or @hashpal = (''); # si solo hay parametros, se necesita
  #impr_debug(__LINE__.' sim1 obedecer',\@hashpal);
  push @{$ref->{listacomeRESU}}, ";    A pedido de opción $refcomienzos";
  my $refternas = [];
  my $ya = '';
  my $comienzo  = $refcomienzos;
      my $yacom = '';
      $comienzo = uc($comienzo); 
      my $comecomienzo = $comienzo;
      $comecomienzo =~ /\s/ and $comecomienzo = "\"$comecomienzo\"";
      foreach my $pal (@hashpal) {
          if ($pal eq '') {
              if ($comienzo =~ /^([CELJR])/) {
                  push @$refternas,['','',$comienzo];
	          $yacom = 1;
	      } elsif ($comienzo =~ /^P/) {
	          push @$refternas, ['P','P',$comienzo];
                  $yacom = 1;
             }
          } elsif ($comienzo =~ /^$pal\s*(\S.*)$/) {
              push @$refternas, [$pal,$ref->{equivpalabra}->{$pal} ,$1];
              $yacom = 1;
          } elsif ($comienzo =~ /^$pal\s*$/) {
               explic("Por favor, especifique más;  
               por ejemplo pida      -todas $comienzo".'R'); 
          };
      };
      $yacom  and $ya = 1 or  avnoseent("la opción -todas $comienzo");        
  #impr_debug(__LINE__.' sim1 obedecer', Dumper $refternas);
  $ya or do {       
       parars1(0,0,"No se puede atender la opción $refcomienzos"); 
  };
  foreach my $refter (@$refternas) {
      my ($pal,$palequiv,$comnombre) = @$refter;
      if ($pal eq 'P') {
          inventar_resultados_par($ref,$comnombre);
      } elsif ($pal eq '') {
          if ($comnombre =~ /^(.)/) {
              inventar_resultados_ele($ref,$palequiv, $1, $comnombre,[]); 
          }   
      } else {
          if ($comnombre) { 
              if ($comnombre =~ s/^N// and $palequiv eq 'V'
                    and defined $ref->{cualobjtextonodo}->{0}) {
                  $comnombre =~ s/\s*//g;
                  inventar_resultados_nodos($ref);
              } elsif ($comnombre =~ /^([CELJR])/) {
                  inventar_resultados_ele($ref,$palequiv, $1, $comnombre,[]); 
              } else {
                  inventar_resultados_nodos($ref);
              }
          }  else {
              parars1(0,0," ... Por favor, especifique más;  
              por ejemplo  pida      -todas $comnombre".'R');
          };
          
      } 
  };     
  my $cuantosnuevo =  @{$ref->{listasceptre}};
  if (not defined $ref->{parsenarchivo} and @{$ref->{listasceptre}} == 0) { 
     parars1(0,0,"De la opción \"-todas  $refcomienzos\": 
                no quedó nada");
  };       
  comfin('fin obedecer_opcion_resultados','sceptre: '
        , @{$ref->{listasceptre}});
  return 1;
} # obedecer_opcion_resultados 
# ---------------------------------------------------------------------------
sub inventar_resultados_nodos{
  comfin('com inventar_resultados_nodos', @_);
  #impr_debug(__LINE__.' sim1 $deficomp', Dumper $deficomp);
  #impr_debug(__LINE__.' sim1 $defiabrev', Dumper $defiabrev);
  my $ref = $_[0]; my @parabuscar;
  my %parabuscar;
  my $maxplantilla = @$nombreplantilla;
  foreach my $ele (@{$ref->{listaDATOS}}) {
      next if $ele =~ /^;/;
      my $obj = $ref->{cualobjele}->{$ele}->[0];
      next if $codlista->[$obj] eq 'T';
      my $plantilla = $plantillalista->[$obj];
      push @{$parabuscar{$plantilla}}, $ref->{uni}->{$ele};
  }; 
  map (do {@{$parabuscar{$_}} = union_conjunto(@{$parabuscar{$_}})}
      , keys %parabuscar);
  my @plantis = grep (scalar @{$parabuscar{$_}} >0,keys %parabuscar);
  #impr_debug(__LINE__.' sim1 @plantis',\@plantis);
  my %nodoplanti;
  foreach my $planti (@plantis) {
      my @conect_0 = ('0');
      my %yaesta;
      while (@conect_0) {
          my @conect_1;
          foreach my $nodo (@conect_0) {
	      map(do {(/^$nodo-(.+)$/ or /^(.+)-$nodo$/) 
                 and not $yaesta{$1} and $1 ne '0' and push @conect_1,$1}
               ,@{$parabuscar{$planti}});
          };
          map($yaesta{$_} = 1, @conect_1);
          @conect_0 = @conect_1;
      };
      my @nodos = sort grep (do{not  $ref->{hashnodoscreados}->{$_}}
                    ,keys %yaesta); 
      foreach my $nodo (@nodos) {
          next if $nodo eq '0';
          if (defined $nodoplanti{$nodo}) {
              avnograv("El nodo $nodo conecta con tierra en circuitos:
      $nombreplantilla->[$nodoplanti{$nodo}] y  $nombreplantilla->[$planti]
      Aparecerán avisos de pedidos repetidos");
          } else {
              $nodoplanti{$nodo} = $planti
          }    
      };
      @nodos or next;
      #my @nodos = keys %{$ref->{cualobjtextonodo}};
      next if $planti == 0;  
      my $abr = $defiabrev->{$planti}->{E};
      my $comp = $deficomp->{$planti}->{E};
      foreach my $nodo (@nodos) {
          my $sceptre = $ref->{TEMP}->{$nodo};
          defined $sceptre or $sceptre = cerofuentear($ref,$nodo);
	  #(my $cosa = $sceptre) =~ s/^V//;
	  #my $obj = $ref->{cualobjele}->{$cosa}->[0];
          my $compp = $deficomp->{$planti}->{E};
          defined $compp and $comp = $compp;
          my $abrp = $defiabrev->{$planti}->{E};
          defined $abrp and $abr = $abrp; 
          defined $comp or $comp = '??,??'; 
          defined $abr  or $abr ='V';
          my $propia = "$abr $nodo"; 
          push @{$ref->{listapedidos}}, "$sceptre($propia,$comp)";#i.r_n
          push @{$ref->{listasceptre}}, "$sceptre"; #i.r_n
          $ref->{tiparg} .= 'a'; #i.r_n
      };
  }; 
  comfin('fin inventar_resultados_nodos', @{$ref->{listapedidos}});
  return;
}
# --------------------------------------------------------------------------
sub inventar_resultados_ele{
  comfin('com inventar_resultados_ele', @_);
  my ($ref,$que,$tipele,$comnombre,$plantis) = @_;
  my $quesceptre = $que;
  $tipele eq 'E' and $que eq 'V' and $quesceptre = '';
  $tipele eq 'J' and $que eq 'I' and $quesceptre = '';
  my $quecomp = $que; $quecomp =~ tr/IV/JE/; $quecomp  or $quecomp = $tipele;
  $que =~ tr/IV/JE/;
  my $planmax = scalar @$nombreplantilla; 
  #impr_debug(__LINE__.' sim1  planmax $comnombre',[$planmax,$comnombre]); 
  #impr_debug(__LINE__.' sim1  @$plantis',Dumper $plantis); 
  defined $plantis and @$plantis or do {
     for (my $i = 1; $i < $planmax; $i++) {
        $plantis->[$i-1] = $i;
     };
  };  
  #impr_debug(__LINE__.' sim1 i.r_e',Dumper $plantis);
  my %siplantis;
  map ($siplantis{$_} = 1,@$plantis); 
  #impr_debug(__LINE__.' sim1  planmax',$planmax); 
  my @liseles = sort keys %{$ref->{ELESPLANT}};
  @liseles = grep (/^$tipele/, @liseles);
  @liseles =grep (/^$comnombre/,@liseles);
  foreach (@liseles) {
      my $obj = $ref->{cualobjele}->{$_}->[0]; 
      my $planti = $plantillalista->[$ref->{cualobjele}->{$_}->[0]];
      next if $planti == 0 or not defined $siplantis{$planti};
      my $abr = $defiabrev->{$planti}->{$quecomp};
      my $comp = $deficomp->{$planti}->{$quecomp};
      defined $comp or $comp = '??,??'; 
      defined $abr or $abr = $quesceptre; 
      #impr_debug(__LINE__.' sim1  $quesceptre $_ $quecomp $abre $comp '
      #        ,[$quesceptre,$_,$quecomp,$abr,$comp]);   
      push @{$ref->{listapedidos}}, "$quesceptre$_($abr $_,$comp)";#i.r_e
      push @{$ref->{listasceptre}}, "$quesceptre$_"; #i.r_e
      $ref->{tiparg} .= 'a';# i.r_e  
  };
  comfin('fin inventar_resultados_ele', @{$ref->{listasceptre}}
         ,@{$ref->{listapedidos}});
  return '';
} # inventar_resultados_ele
# ---------------------------------------------------------------------------
sub enviar_resultados_archivo{ #los nombres sugieren parametros,pero pueden no 
  comfin('com enviar_resultados_archivo', @_);
  #las constantes las manda a archivo; devuelve ref a lista de los otros
  my ($ref,$que,$refpars,$parahash,$archv) = @_;
  my @pars = @$refpars;
  #impr_datos(__LINE__.' sim1', ['PARAMETROS'],$ref);
  @pars = grep(do{not defined $ref->{$parahash}->{$_}},@pars);
  map(s/^D//,@pars);
  #impr_debug(__LINE__.' sim1 @pars',\@pars);
  my %elegidos;
  my @parsnum = grep(do{defined $ref->{TIPPARAMETROS}->{$_}
                       and lc($ref->{TIPPARAMETROS}->{$_}) eq 'n'
                       and $elegidos{$_} = 1},@pars);
  #impr_debug(__LINE__.' sim1 @parsnum',\@parsnum);
  @pars = grep(do{not defined $elegidos{$_}},@pars); 
  #impr_debug(__LINE__.' sim1 @pars',\@pars);  
  my $texto =  '#'.'-' x 10 ." Parámetros o elementos constantes pedidos por "
              . "$ref->{PROPIO}\n";  
  foreach (sort @parsnum) {
      $texto .= "$_ = " . para_sceptre($ref,$ref->{PARAMETROS}->{$_}, 'n'). "\n";   
  }
  $ref->{parsenarchivo} = $texto.'#'.'-' x 10 . "\n";
  comfin('fin enviar_resultados_archivo', @parsnum,'....',@pars);
  return \@pars;
}#enviar_resultados_archivo
# ---------------------------------------------------------------------------
sub inventar_resultados_par{
  comfin('com inventar_resultados_par', @_);
  my ($ref,$comienzo) = @_;
  my $tiparg ='';
  my @pars = sort keys %{$ref->{PARAMETROS}};
  @pars = grep(do{/$comienzo/ or /^D$comienzo/},@pars);
  #impr_debug(__LINE__.' sim1 @pars',\@pars);
  my $refpars = enviar_resultados_archivo($ref,'PARAMETROS'
                ,\@pars,'parametroscreados'); 
  #impr_debug(__LINE__.' sim1 @$refpars',$refpars);
  #impr_debug(__LINE__.' sim1 ',$ref->{parsenarchivo});
  @pars = grep(do{length($_) < 7},@$refpars);# se inventan como resultado
  foreach (@pars) {
      my $sceptre = $_;
      defined $ref->{TIPPARAMETROS}->{$_}
          and  $ref->{TIPPARAMETROS}->{$_} =~ /[pa]/ 
          and $sceptre = $ref->{PARAMETROS}->{$_}; 
      completar_guardarref_pedido($ref,'p',0,$sceptre,  #inv_r_par
        '','','',$_,$_);
  };
  #impr_debug(__LINE__.'sim1 inv_res_par',$ref->{listapedidos});
  comfin('fin inventar_resultados_par');
  return {},$tiparg,\@pars;
} 
# inventar_resultados_par
# ---------------------------------------------------------------------------
sub inventar_resultados{
   comfin('com inventar_resultados', @_);
   # si no se ha pedido   ninguno ....
   my ($ref,$solopar) = @_;
   $ref->{listacomeRESU}= [';    Propuestos por simusol'];
   my ($reflista, @lista,$tiparg);
   if (defined $ref->{ELESPLANT}) {
       inventar_resultados_nodos($ref);
       defined $ref->{listasceptre} or 
           inventar_resultados_ele($ref,'I','R','R',[]);
   } else {
        inventar_resultados_par($ref, 'P'); #$comienzo empieza con P
   };
   if (not defined $ref->{listapedidos}) { 
       parars1(66,$ref,"No hay nada interesante para tomar como resultado");
   };
   cargar_datos($ref,'RESULTADOS','lista'
               , 'listaresu' .join(';',@{$ref->{listasceptre}})
	 ,',',$ref->{tiparg} ,0,__LINE__.' sim1 inv._result');
   comfin('fin inventar_resultados', @{$ref->{listapedidos}});
   return '';
} #inventar_resultados
#---------------------------------------------------------------------------
sub mirar_cuadro_graficos{# buscando necesidad de resultados
  my ($ref) = @_;
  my %todos = %{$ref->{refvalores}->{GRAFICOS}};
  my @lista_por_graf = (); my $coderr;
  foreach (keys %todos) { 
      my @listita  = @{$todos{$_}};
      ($coderr,@listita) = juntar_por_paren(',',@listita); 
      parars1($coderr,0) if $coderr;
      map(s/(\W)CALCULADO(\W)/$1SIMULADO$2/ig, @listita);
      @listita = grep(s/^.*=\s*SIMULADO\s*,\s*//,@listita);
      foreach (@listita) {
          my @resu = split /[:,]+\s*/;
          @resu = grep(/^\D/,@resu);
          @resu = grep(do{uc($_) ne 'TIEMPO' and uc($_) ne 'TIME'}, @resu);
          push  @lista_por_graf,@resu;
      }; 
  };
  return @lista_por_graf;
} #mira_cuadro_graficos 
#---------------------------------------------------------------------------
sub mirar_cuadro_resultados{
  # solo detecta errores groseros
  comfin('com mirar_cuadro_resultados', @_);
  my $ref = $_[0];
  #impr_obj(__LINE__.' sim1','[R]');
  #impr_debug(__LINE__.' sim1 ',[keys %{$ref->{refvalores}}]);
  my @listapedidos = (); my $coderr;
  if (defined $ref->{refvalores}->{RESULTADOS}) {
      my %todos = %{$ref->{refvalores}->{RESULTADOS}};
      #por si hay mas de un cuadro 
      scalar keys %todos >1 and
      avnograv("Más de un cuadro de RESULTADOS; orden no establecido");
      foreach (keys %todos) { 
          my @listita  = @{$todos{$_}};
          ($coderr,@listita) = juntar_por_paren(',',@listita); 
          parars1($coderr,0) if $coderr;
          push @listapedidos, @listita;
      };
  } elsif (defined $ref->{refvalores}->{GRAFICOS}) {
      @listapedidos = mirar_cuadro_graficos($ref); 
  };
  #impr_debug(__LINE__.' sim1 @listapedidos',\@listapedidos);
  $ref->{listacomeRESU} = [];
  @{$ref->{listacomeRESU}} = grep(/^\s*;/,@listapedidos);
  @listapedidos = grep(do {$_ !~ /^\s*;/},@listapedidos);
  my $textolistacoma = join ',', @listapedidos;
  #impr_debug(__LINE__." sim1 @listapedidos ",  \@listapedidos);
  while ($textolistacoma =~ s/\,\s*\,+\s*/\,/) {};  
  $textolistacoma =~ s/\s+\,/\,/g; $textolistacoma =~ s/\,\s+/\,/g;
  # se perdona error de comas repetidas 
  ($coderr,@listapedidos) = 
     juntar_por_paren(',' , split (',',$textolistacoma));
  parars1($coderr,0) if $coderr;
  #impr_debug(__LINE__." sim1 listapedidos ", Dumper \@listapedidos);
  # {listacomeRESU} para los comentarios pedidos como resultados
  foreach my $parte (@listapedidos) { # para separar comentarios
      next unless defined $parte;
      if ($parte =~ s/^([^;]*);/;/) {
           push @{$ref->{"listacomeRESU"}}, $parte; 
           $parte = $1; 
           $parte =~ s/(\S)\s*$/$1/; 
      };
      my $parteori = $parte;
      if ($parte =~s/([:][^\(\)]*)//) {
          avnoseent("el agregado en el pedido de resultado 
            $parteori,   agregado $1 ");
          mensaje("Si necesita cambiar el sentido:
                  desconecte el ícono del elemento,
                  simetrícelo y  reconéctelo");
          s/\s*$//;
      };
  };
  #impr_debug(__LINE__." sim1 listacomeRESU ", $ref->{listacomeRESU});
  controlar_pedidos_resultados($ref, @listapedidos);
  #impr_debug(__LINE__." sim1 tiparg ", $ref->{tiparg});
  #impr_debug(__LINE__." sim1 listapedidos ", $ref->{listapedidos});
  #impr_debug(__LINE__." sim1 listasceptre", $ref->{listasceptre});
  cargar_datos($ref,'RESULTADOS','lista'
               , 'listaresu' .join(';',@{$ref->{listasceptre}})
	 ,',',$ref->{tiparg} ,0,__LINE__.' sim1 mirar_cuadro');
  comfin('fin mirar_cuadro_resultados', @{$ref->{listapedidos}});
  return '';
} #mirar_cuadro_resultados 
#---------------------------------------------------------------------------
sub interpretar_resultados{
  comfin('com interpretar_resultados', @_);   
  my ($ref,$solopar) = @_;
  my ($ele,$que);my $haypedidos = '';
  my $refcomienzo = $opt_hash{todas}; my $coderr = 1;
  my $hayenarchivo = 0;
  if ($refcomienzo) {
        $hayenarchivo = obedecer_opcion_resultados($ref,$refcomienzo)
        #para si no hubo nada
  } elsif  (defined $ref->{refvalores}->{RESULTADOS}
           or defined $ref->{refvalores}->{GRAFICOS}) {
        mirar_cuadro_resultados($ref); 
  };
  defined $ref->{listapedidos} or $hayenarchivo or 
      inventar_resultados($ref); #si no consigue, para
  not defined $ref->{listapedidos} and return;
  my @listapedidos = @{$ref->{listapedidos}};  
  my @listasceptre = @{$ref->{listasceptre}};
  my $stringtiparg = $ref->{tiparg};

 
  @listasceptre = @{$ref->{listasceptre}}; 
  #impr_debug(__LINE__.' sim1 int_res', Dumper \@listasceptre); 
  @listasceptre = union_conorden(@listasceptre);
  #impr_debug(__LINE__.' sim1 int_res', "@listasceptre"); 
  my @times = grep( do{$_ eq 'TIME' or $_ eq 'TIEMPO'}, @listasceptre);
  my ($propia,$magn, $uni);
  if ($listasceptre[0] ne 'TIME' and $listasceptre[0] ne 'TIEMPO') {
       if (@times) {
           avgrav('El tiempo, como pedido de resultado, 
             sólo puede aparecer en el primer lugar');
           parars1(201,$ref);
       };
       unshift @listapedidos, "TIME(Tiempo,tiempo, s)";
       ($propia,$magn, $uni) = ('Tiempo','tiempo','s');
       $stringtiparg = 't'. $stringtiparg;
  } else {
      shift @listasceptre;
      $listapedidos[0] =~ /T\w+\((.*)\,(.+)\,(.+)\)$/;
      ($propia,$magn, $uni) = ($1,$2,$3);
  };
  unshift @listasceptre , 'TIME';      
      (not defined $magn or $magn = '??') and $magn = 'tiempo';        
      (not defined $uni or $uni eq '??') and $uni = 's';
      if (lc($propia) eq 'tiempo' and $uni ne 's') { 
          my ($valor,$unip) = separar_unidad($uni); 
          if (not defined $unist{lc($unip)}   or
              abs($factort{$unist{lc($unip)}} * $valor -1) > 0.01 ) {
              avnograv("$uni no equivale a 's'; cambio a 's'"); 
              $uni = 's';
          };
      };
  #impr_debug(__LINE__.' sim1 int_res', \@listasceptre);
  #impr_debug(__LINE__.' sim1 int_res', \@listapedidos);
  my (@lispropias,@lismagn,@lisuni,@indicebueno);
  @lispropias = ($propia); @lismagn = ($magn); @lisuni = ($uni);
  @indicebueno = (1);         
 

  my (@listamala, @lisrepetidos,@talcuallistamala,%listamalanoex);
  my $cuantosmalos = 0;
  my @listatiparg = split //,$stringtiparg;
  my ($isceptre,%cualoutputsceptre,%cualotrasceptre);
 
  for(my $i = 1; $i <= @listasceptre; $i++) {
       $cualoutputsceptre{$listasceptre[$i-1]} = $i;
  };
 my $perdidos; 	   
 for(my $ipropia = 2; $ipropia <= @listapedidos; $ipropia ++) {
      my $valor = $listapedidos[$ipropia-1]; 
      my $tipo = $listatiparg[$ipropia-1]; 
      $valor =~ s/^([^\(\)]+)\(//; my $sceptrepal = uc$1; 
      $valor =~  s/\)$//; 
      my @lista = split /,/, $valor;
      #impr_debug(__LINE__.' sim1 $valor $tipo @lista'
      #      ,[$valor,$tipo,' ', \@lista]);  
      my ($propia,$magn, $uni) = @lista;
      my $ksceptre;
      push @lispropias, $propia;
      push @lismagn, $magn; push @lisuni, $uni; 
      if ($tipo eq 'e') {       
	  #push @talcuallistamala,  $listapedidos[$ipropia-1];
          push @indicebueno, 0;
          $cuantosmalos ++;
          $ksceptre = 0;
      } else {
	  $sceptrepal eq 'TIEMPO' and $sceptrepal ='TIME';
          $ksceptre = $cualoutputsceptre{$sceptrepal};
	  push @indicebueno, $ksceptre;
          if ($ksceptre < $ipropia-$cuantosmalos) {
              push @lisrepetidos, $ipropia;
              $cuantosmalos ++; 
          };
          push @{$ref->{lisnum}-> {"$magn,$uni"}},$ipropia;	 
          push @{$ref->{listalisnum}}, "$magn,$uni";
      };
  }; #foreach $ipropia
  #impr_debug(__LINE__.' sim1 lispropias',\@lispropias);
  #impr_debug(__LINE__.' sim1 inv.r lisnum', Dumper $ref->{lisnum});
  @listasceptre > 0 and @listasceptre  > $cuantosmalos and do{
      $haypedidos = 1;
      my $valor = 'LISTARESU(' . join(';',@listasceptre) . ')';
      impr_debug(__LINE__.' sim1 $valor', $valor);
      my $valortalcual = 'LISTARESU(' . join(';',@lispropias) . ')';
      $ref->{TALCUALRESULTADOS}->{lista} = $valortalcual; 
      cargar_datos($ref,'RESULTADOS','lista',$valor, ',' , $stringtiparg,0
                        ,__LINE__.' sim1 int.resultados'); 
  };
  #impr_datos(__LINE__.' sim1 int r', ['RESULTADOS'], $ref);
  #if (@talcuallistamala) {
  #     my $textolistamala = join ("\n     ",(@talcuallistamala));  
  #     avnoseent(" pedidos de resultados:\n     $textolistamala"); 
  #};
 if (@lisrepetidos) {
      my (@cuales, @cualesrep,$expli);
      map(do{push(@cuales, $lispropias[$indicebueno[$_-1]-1]);
	     push(@cualesrep, $lispropias[$_-1]);
           $expli .=
           "\n    $lispropias[$_-1],$lispropias[$indicebueno[$_-1]-1]: "
          . " se refieren a " . $listasceptre[$indicebueno[$_-1]-1]      }
          , @lisrepetidos);
      avnograv("Hay pedidos de resultados que, como variables del Sceptre,
            repiten pedidos anteriores $expli"); 
          # @cualesrep:    @cuales");
  };
  @{$ref->{listalisnum}} = union_conorden(@{$ref->{listalisnum}});
  $ref->{lisoutputssceptre} = \@listasceptre;
  $ref->{lispropiasvars} = \@lispropias;	 
  $ref->{lisunidades}= \@lisuni;
  $ref->{lismagnitudes} = \@lismagn;  
  $ref->{indicebueno} = \@indicebueno;
  #impr_debug(__LINE__.' sim1 @listasceptre ',"@listasceptre");
  #impr_debug(__LINE__.' sim1 @lispropias ',"@lispropias");
  #impr_debug(__LINE__.' sim1 @lismagn ',"@lismagn");
  #impr_debug(__LINE__.' sim1 @lisuni ',"@lisuni"); 
  #impr_debug(__LINE__.' sim1 listalisnum ',Dumper $ref->{listalisnum});
  #impr_debug(__LINE__.' sim1 lissnum ',Dumper \%{$ref->{lisnum}});
  #impr_debug(__LINE__.' sim1 @indicebueno ',"@indicebueno");
  comfin('fin interpretar_resultados',  ['RESULTADOS'], $ref,'impr');  
}# interpretar_resultados
# ---------------------------------------------------------------------------
sub filtrar_rerun{
  comfin('com filtrar_rerun', @_);
  # Si los pedidos de valores iniciales, parámetros o controles  son listas
  #   se deja el primero de la lista  y el resto irá a $rerun en su momento
  my ($lisque,$ref) = @_;
  $ref->{rerun} = {};
  my $PROPIO = $ref->{PROPIO}; 
  my $PROPIOSINDIA = $PROPIO; $PROPIOSINDIA =~ s/\.dia$//;
  if (@{$ref->{'STOP TIME'}->{lista}} >1
         and @{$ref->{'START TIME'}->{lista}} == 1) {
      my @lista = ($ref->{'START TIME'}->{lista}->[0]
                            , @{$ref->{'STOP TIME'}->{lista}});
      my $cuantos = scalar @lista;
      my @listaarch = ("${PROPIOSINDIA}.simul");
      for (my $i=1; $i< $cuantos-1; $i++) {
          push @listaarch, "${PROPIOSINDIA}_$i.simul"
      };
      $ref->{archrerun} = join ',', @listaarch;
      partir_tablas($ref,'TIEMPO',@lista);
      cargar_datos($ref,'CONTROLES','IC FOR RERUNS','PRECEDING RESULTS'
                   ,'a','',0);
      push @{$ref->{listaCONTROLES}}, 'IC FOR RERUNS';
      $ref->{nrerun} = $cuantos;
      cargar_datos($ref,'CONTROLES','RERUN DESCRIPTION',1,'a','',0);
      return;
  };#if                 
  my $cuantos = 0; #para todos se completará al mismo cuantos 
  #impr_datos(__LINE__.' sim1', ['INICIALES','PARAMETROS','CONTROLES'], $ref);
  foreach my $que (@$lisque) {
      my $pedidos = $ref->{$que};
      my @concoma = grep (/\,/,values %$pedidos);
      next  unless @concoma;
      foreach my $key (keys %$pedidos) {
	  my $valor = $pedidos->{$key};
         next unless 
            ($que eq 'CONTROLES' and $ref->{CONTROLES}->{$key} =~ /\,/)
	    or ($que ne 'CONTROLES' and $ref->{"TIP$que"}->{$key} eq ',');
	  $ref->{"TIPARG$que"}->{$key}  =~ /^n+$/ 
             or $key eq 'INTEGRATION ROUTINE' or do{
              parars1(103,$ref, "Los valores para \"RERUN\" deben ser numéricos
                    no como en \"$valor\"");
          };   
          $valor =~ s/listalis\((.+)\)$/$1/i;
          my @lista = split ',', $valor;
          @lista >$cuantos and $cuantos = @lista; 
          my $master = $lista[0];
          if ($que eq 'INICIALES') {
              $ref->{"TIP$que"}->{$key} = 'n';
              $ref->{"TIPARG$que"}->{$key} = '';
              $pedidos->{$key} = $master;
          } elsif ($que eq 'PARAMETROS') {
              if (length($key) > 6) {
              parars1(104,$ref
                ,"Debe cambiar el nombre del parametro $key;
                    (pedido:     $key = $valor)
                 ese nombre largo no puede llegar a sceptre para hacer rerun");
	      };
              $ref->{PARAMETROS}->{$key} = $master;
              $ref->{TIPARGPARAMETROS}->{$key} = '';
              # para que no se sustituyan esos parámetros; 
              # se necesitan para RERUN
              # o para RESULTADOS? el tipo se deja en , 
          } elsif ($que eq 'CONTROLES') {#importa para INTEGRATION ROUTINE
	      $pedidos->{$key} = $master;
          };# if elsif elsif $que INICIALES    
          if ($ref->{INICIALES}->{$key} and $ref->{PARAMETROS}->{"D$key"}){
              $ref->{rerun}->{PARAMETROS}->{$key} = \@lista
	  } else {
              $ref->{rerun}->{$que}->{$key} = \@lista;
          };
      };#foreach $key   
  };#foreach $que
  $ref->{nrerun} = $cuantos;
  my @listaarch = ("${PROPIOSINDIA}.simul");
  for (my $i=1; $i< $cuantos; $i++) {
      push @listaarch, "${PROPIOSINDIA}_$i.simul"
  };#for #i
  $ref->{archrerun} = join ',', @listaarch;
  my @listamarcas;
  # no se marca en relacion a START TIME or STOP TIME porque se ve ?posible?
    foreach my $que (sort keys %{$ref->{rerun}}) {
      foreach my $key (sort keys %{$ref->{rerun}->{$que}}) {
          my $keyori = $ref->{INIoriginal}->{$key};
          defined $keyori or $keyori = $key;
          my @lista = @{$ref->{rerun}->{$que}->{$key}};
          my $texto = "$lista[0] " x $cuantos;
          my @listac = split '\s+', $texto;
          push @lista , @listac; @lista = @lista[0..$cuantos-1];
          (my $keylimpio = $keyori) =~ s/_//;
          for(my $rr = 0; $rr < $cuantos; $rr++) {
              push @{$listamarcas[$rr]}, "$keylimpio = $lista[$rr]";
          };      
      };#foreach $key ..rerun
  }; #foreach $que .. rerun
  map($_ ='(' .  join(';', @{$_}) .')', @listamarcas);
  $ref->{marcasrerun} =  join ',' , @listamarcas;
  comfin('fin filtrar_rerun', '',@listamarcas
                   , ['PARAMETROS','INICIALES','CONTROLES'],$ref,'impr');
} #filtrar_rerun
# ---------------------------------------------------------------------------
sub interpretar_tiempos{
  #se refiere a los tiempos para controlar de la simulación
  # en el cuadro TIEMPO se pone la lista de tiempos de corte de la simulacion
  # al igual que en STOP TIME
  comfin('com interpretar_tiempos',@_);
  my $refcirc = $_[0];
  my $refvalores = $refcirc->{refvalores};
  # $unidad sera la unidad elegida para entregar resultados
  #TIME, en ingles porque aparece en sceptre
  my (@listaque,%lista);
  my %todo =
      ('TIEMPO' => 'STOP TIME',
       'START' => 'START TIME',
       'STOP' => 'STOP TIME'
      );    
  if (defined $refvalores->{TIEMPO}) {
      scalar keys %{$refvalores->{TIEMPO}} > 1 and 
         parars1(161, $refcirc, 
           "Por favor no incluya más de un cuadro TIEMPO"); 
      (my $lisvalues) = values %{$refvalores->{TIEMPO}}; 
      map (s/\;.*$//g,@$lisvalues); @$lisvalues = grep(/\w/,@$lisvalues); 
      $lista{TIEMPO} = join ',', @$lisvalues;
      push @listaque, 'TIEMPO';
  };
  #impr_debug(__LINE__. ' sim1 %lista', \%lista);
  if (defined $refcirc->{tiempo}) {
      $lista{START} = $refcirc->{tiempo}->{'START TIME'};
      defined $lista{START} and push @listaque, 'START';
      $lista{STOP} = $refcirc->{tiempo}->{'STOP TIME'};
      if (@listaque and $listaque[0] eq 'TIEMPO' 
            and defined $lista{STOP}) {
          avnograv ("Como hay información en el cuadro TIEMPO,
           se ignorará la información del cuadro CONTROLES  para STOP TIME");
	     delete $lista{STOP};
     } elsif (defined $lista{STOP}) {
         push @listaque, 'STOP';
     };
  };
  foreach my $que (reverse @listaque) {
      (my $reflista,$unidadtiempo) = tiempos($lista{$que},$refcirc);
      #impr_debug(__LINE__.' sim1 $reflista $unidadtiempo ',
      #              $unidadtiempo . ' '. Dumper $reflista);
      $refcirc->{$todo{$que}}->{tiempoorig} = $lista{$que};
      $refcirc->{$todo{$que}}->{unidad} = $unidadtiempo;
      $refcirc->{$todo{$que}}->{lista} = $reflista;
  };#foreach $que
  #valores por defecto
  if (not defined $refcirc->{'STOP TIME'}->{unidad}) {
      if (defined $refcirc->{'START TIME'}->{unidad}) {
          $refcirc->{'STOP TIME'}->{unidad} = 
                $refcirc->{'START TIME'}->{unidad};
      } else {
          $refcirc->{'STOP TIME'}->{unidad} = $unidadtiempo; 
          $refcirc->{'START TIME'}->{unidad} = $unidadtiempo;
      };
  };
  #impr_debug(__LINE__.' sim1 START', $refcirc->{'START TIME'});
  #impr_debug(__LINE__.' sim1 STOP', $refcirc->{'STOP TIME'});
  controlar_tiempos($refcirc);
  comfin('fin interpretar_tiempos');
}; # interpretar_tiempos
# ----------------------------------------------------------------------------
sub help{
    pod2usage({-verbose => 0
           ,-exit => 1
	   ,-message => "   $progname $version
       es parte del conjunto de scripts de S I M U S O L
            más ayuda con   
	       man $progname
	    y luego salga con   q\n"   
	   });
 }
#----------------------------------------------------------------------------
sub version{
    print "\n      $progname  $version\n\n";
    exit 0
}


 
